#pragma once

namespace Adapters
{

	//MotionVector adapters
	class Adapter
	{
		virtual void nullfunction() {}//allows use of dynamic_cast to simulate virtual template methods
	};
	class Direct : public Adapter
	{
	public:
		Direct() {}

		template<int subsample>
		MotionVector apply(MotionVector v) const;

		template<>
		MotionVector apply<1>(MotionVector v) const
			{return v;}

		template<>
		MotionVector apply<2>(MotionVector v) const
			{return MotionVector(v.x>>1, v.y>>1);}
	};

	class ScaleVector : public Adapter
	{
	public:
		int semiscaledfraction;
		int halfsemiscaledfraction;
	public:
		ScaleVector(int _fraction) : 
			semiscaledfraction(semiscaledpart(_fraction)), 
			halfsemiscaledfraction(semiscaledfraction/2) {}
		
		template<int subsample>
		MotionVector apply(MotionVector v) const;

		template<>
		MotionVector apply<1>(MotionVector v) const
			{return MotionVector(semiscaledpart(v.x)*semiscaledfraction, semiscaledpart(v.y)*semiscaledfraction);}

		template<>
		MotionVector apply<2>(MotionVector v) const
		{
			MotionVector temporary = MotionVector(semiscaledpart(v.x)*semiscaledfraction, semiscaledpart(v.y)*semiscaledfraction);
			return MotionVector(temporary.x/2, temporary.y/2);
		}
			//{return MotionVector(semiscaledpart(v.x)*halfsemiscaledfraction, semiscaledpart(v.y)*halfsemiscaledfraction);}
	};

}