#include "stdafx.h"
#include "sumstretch.h"

namespace MaskMaker
{
	ConstantMaskMaker::ConstantMaskMaker(int _constant) : constant(_constant)
	{
	}

	void ConstantMaskMaker::operator()(PVideoFrame &result, const PMotionFrame motion) const
	{
		//const int widthinblocks = motion.GetWidth();
		//const int heightinblocks = motion.GetHeight();
		const int resultwidth = result->GetRowSize();
		const int resultheight = result->GetHeight();
		const int resultpitch = result->GetPitch();

		unsigned char *resultrow = result->GetWritePtr();
		for(int y = 0; y < resultheight; ++y, resultrow +=  resultpitch)
			for(int x = 0; x < resultwidth; ++x)
				resultrow[x] = constant;
	}

	SumStretchMaskMaker::SumStretchMaskMaker(int _multiplier) : multiplier(_multiplier)
	{
	}

	void SumStretchMaskMaker::operator()(PVideoFrame &result, const PMotionFrame motion) const
	{
		apply<Adapters::Direct>(result, motion, Adapters::Direct());
	}

	void SumStretchMaskMaker::operator()(PVideoFrame &result,  const PMotionFrame motion, const Adapter &adapter) const
	{
		if(const Adapters::Direct *direct = dynamic_cast<const Adapters::Direct *>(&adapter))
			apply<Adapters::Direct>(result, motion, *direct);
		else if(const Adapters::ScaleVector *multipliervector = dynamic_cast<const Adapters::ScaleVector *>(&adapter))
			apply<Adapters::ScaleVector>(result, motion, *multipliervector);
		else throw;
	}

}