#pragma once

namespace MaskMaker
{
	inline int positivepart(int number) {return ((number < 0) ? 0 : number);}
	inline int negativepart(int number) {return ((number > 0) ? 0 : -number);}

	template<class AdapterType>

	void SumStretchMaskMaker::apply(PVideoFrame &result, const PMotionFrame motion, const AdapterType adapter) const
	{
		const int widthinblocks = motion.GetWidth();
		const int heightinblocks = motion.GetHeight();
		const int motionpitch = motion.GetPitch();
		const int resultwidth = result->GetRowSize();
		const int resultheight = result->GetHeight();
		const int resultpitch = result->GetPitch();

		const CompressedMotionVector *motionrow = motion.GetReadPtr();
		unsigned char *resultrow = result->GetWritePtr();

		for(int y = 0; y < heightinblocks; ++y)
		{
			for(int x = 0; x < widthinblocks; ++x)
			{
				int result = 0;
				MotionVector thismotion = adapter.apply<1>(MotionVector(motionrow[x]));
	
				if(x > 0)
					result += negativepart(thismotion.x - adapter.apply<1>(MotionVector(motionrow[x-1])).x) / (scale/64) * multiplier; 
				if(x < widthinblocks - 1)
					result += negativepart(adapter.apply<1>(MotionVector(motionrow[x+1])).x - thismotion.x) / (scale/64) * multiplier; 
				if(y > 0)
					result += negativepart(thismotion.y - adapter.apply<1>(MotionVector(motionrow[x-motionpitch])).y) / (scale/64) * multiplier; 
				if(y < heightinblocks - 1)
					result += negativepart(adapter.apply<1>(MotionVector(motionrow[x+motionpitch])).y - thismotion.y) / (scale/64) * multiplier; 

				//result is now scaled by 256*multiplier
				resultrow[x] = min(result/256, 255);
			}
			for(int x = widthinblocks; x < resultwidth; ++x)
				resultrow[x] = resultrow[x - 1];
			motionrow += motionpitch;
			resultrow += resultpitch;
		}
		for(int y = heightinblocks; y < resultheight; ++y)
		{
			for(int x = 0; x < resultwidth; ++x)
				resultrow[x] = resultrow[x - resultpitch];
			resultrow += resultpitch;
		}
	}
}