#include "stdafx.h"
#include "filters.h"

namespace Filters
{

	UniformMotion::UniformMotion(PClip _child, MotionVector _constantmotionvector, IScriptEnvironment *env)
	: MotionFilter(_child), constantmotionvector(_constantmotionvector)
	{
		//Colour space and size checks are in the parent class MotionFilter
	}

	PMotionFrame UniformMotion::GetMotionFrame(int n, IScriptEnvironment *env) 
	{
		PMotionFrame result = env->NewVideoFrame(vi);
		const int resultpitch = result.GetPitch();
		const int widthinblocks = result.GetWidth();
		const int heightinblocks = result.GetHeight();

		CompressedMotionVector *resultrow = result.GetWritePtr();
		for(int y = 0; y < heightinblocks; ++y)
		{
			for(int x = 0; x < widthinblocks; ++x)
				resultrow[x] = CompressedMotionVector(constantmotionvector);
			resultrow += resultpitch;
		}
		return result;
	}


	AVSValue __cdecl Create_UniformMotion(AVSValue args, void *user_data, IScriptEnvironment *env) 
	{
		MotionVector constant(
			static_cast<int>(args[1].AsFloat()*scale+0.5), 
			static_cast<int>(args[2].AsFloat()*scale+0.5));
		return new UniformMotion(args[0].AsClip(), constant, env);  
	}
}
