#pragma once
#include "UpdateSet.h"

namespace Generation
{

	template<class Interpolation>
	class Update
	{
		const int width, height;
		const int widthinblocks, heightinblocks;

		const PVideoFrame current;
		const PVideoFrame previous;
		const PMotionFrame temporal;
		PMotionFrame result;

		const int currentpitch;
		const int previouspitch;
		const int temporalpitch;
		const int resultpitch;

		const unsigned char *currentpointer;
		const unsigned char *previouspointer;

		UpdateSet updateset;

		bool isvalid(const XY position, MotionVector);
		void initialiseupdateset();


	public:
		Update(const PVideoFrame _current, const PVideoFrame _previous, const PMotionFrame _temporal, int seed, IScriptEnvironment *, const VideoInfo &, const bool useassembly);
		
		operator PMotionFrame();
	};
}