#ifndef _WEIGHTED_AVERAGE_H_
#define _WEIGHTED_AVERAGE_H_

#include <vector>
#include <fstream>

using namespace std;

struct WeightedFrame
{
	PVideoFrame frame;
	double weight;
	WeightedFrame(PVideoFrame _frame, double _weight)
		: frame(_frame), weight(_weight) {}
};

class WeightedAverage
{
	const static int scalepower = 6+8/**/;
	const static int scale = 64*256/**/;
	PVideoFrame result;

	//int width, height;
	int length;
	vector<PVideoFrame> source;
	vector<int> scaledweight;

	void averageplane(int plane, IScriptEnvironment* env);
	void averageplane_P3(int plane, IScriptEnvironment* env);
	void averageplane_P4(int plane, IScriptEnvironment* env);
public:
	WeightedAverage(const vector<WeightedFrame> &data, IScriptEnvironment* env, VideoInfo vi);
	operator PVideoFrame() const {return result;}
};


#endif
