#include "stdafx.h"

#include "Weightedaverage.h"

void WeightedAverage::averageplane_P3(int plane, IScriptEnvironment* env)
{
	if (length > 32) 
		env->ThrowError("Optimised WeightedAverage can only process 32 frames.");
	if (length%2==1)
		env->ThrowError("Optimised WeightedAverage requires even number of frames.");
	for (int i=0;i<length;++i)
		if ( scaledweight[i] != short (scaledweight[i]) )
			env->ThrowError("Optimised WeightedAverage weight coefficients too large.");

	_declspec(align(16)) const unsigned char* sourcep[64];
     for (int i=0;i<length;++i)
               sourcep[i] = source[i]->GetReadPtr(plane);
	//for (int i=0;i<length/2;++i)
	//{
	//	sourcep[4*i] = source[2*i]->GetReadPtr(plane);
	//	sourcep[4*i+1] = source[2*i+1]->GetReadPtr(plane);
	//}
	unsigned char* resultp = result->GetWritePtr(plane);

	const int width = source[0]->GetRowSize(plane);
	const int height = source[0]->GetHeight(plane);

	/*const*/ int source_pitch[32];
	for (int i=0;i<length;++i)
		source_pitch[i] = source[i]->GetPitch(plane);
	const int result_pitch = result->GetPitch(plane);

	_declspec(align(16)) int rounder[4];
	for (int j=0;j<4;++j)
		rounder[j] = scale/2;

	_declspec(align(16)) short multiplier[16*8];
	for (int i=0;i<length/2;++i)
		for (int j=0;j<8;j+=2)
		{
			multiplier[i*8 + j]      = short (scaledweight[2*i]);
			multiplier[i*8 + j+1]   = short (scaledweight[2*i+1]);
		}

	//const int length8 = length*8;
	       const int length4 = length*4;
const int eightwidth = (width% 8 == 0) ? width : (width + 8 - (width% 8));

	for (int y = 0; y < height; ++y)
	{//*	
		 __asm
		 {
			  mov     ebx, [eightwidth]//
			  mov     edi, [resultp]//
			  pxor    mm7, mm7
spatial:
			  movq  mm4, [rounder]
			  movq  mm5, [rounder]

			  mov     eax, [length4]//
temporal:
			  mov     ecx, [sourcep+eax-8]
			  mov     edx, [sourcep+eax-4]
			  movd    mm0, dword ptr [ecx+ebx-4]    //ecx points to frame n
			  movd    mm1, dword ptr [edx+ebx-4]    //edx points to frame n+1

			  movq  mm3, [multiplier+2*eax-16]     //multiplier
			  punpcklbw mm0, mm1
			  pshufw  mm1, mm0, 0x4e
			  punpcklbw mm0, mm7
			  punpcklbw mm1, mm7

			  pmaddwd mm0, mm3
			  pmaddwd mm1, mm3
			sub     eax, 8
			  paddd   mm4, mm0
			  paddd   mm5, mm1

			jnz      temporal
			  //now have FOR pixels worth of result in DWORDs of xmm5:xmm4

			  psrad   mm4, 8+6
			  psrad   mm5, 8+6
			  packssdw mm4, mm5
			  pmaxsw  mm4, mm7//necessarily*** open?
			  //now have eight pixels worth of result in WORDs of xmm4

			  packuswb mm4, mm7
			  movd    dword ptr  [edi+ebx-4], mm4

			  sub     ebx, 4
			  jnz      spatial
			  emms

		 }//*/
		 for (int i=0;i<length;++i)
			  sourcep[i] += source_pitch[i];
		 resultp += result_pitch;
	}
}
