#include "stdafx.h"

#include "constant.h"
#include "Engine.h"

namespace Constant
{
	EngineNumber move(Accuracy accuracy) {return (MOVE << 16) + accuracy;}
	EngineNumber warp(Accuracy warpaccuracy, Accuracy moveaccuracy) {return (WARP << 16) + (warpaccuracy << 8) + moveaccuracy;}

	Engines::Engine *enginefromnumber(EngineNumber number)
	{
		if(number == move(PIXEL))						return new Engines::MoveEngine<_Pixel>;
		if(number == move(HALFPIXEL))					return new Engines::MoveEngine<HalfPixel>;
		if(number == move(BILINEAR))					return new Engines::MoveEngine<Bilinear>;//throw AvisynthError("Motion: moveaccuracy = bilinear not yet supported.");

		if(number == warp(PIXEL, PIXEL))				return new Engines::SimpleWarpEngine<_Pixel, _Pixel>;
		if(number == warp(PIXEL, HALFPIXEL))			return new Engines::SimpleWarpEngine<_Pixel, HalfPixel>;
		if(number == warp(PIXEL, BILINEAR))			return new Engines::SimpleWarpEngine<_Pixel, Bilinear>;//throw AvisynthError("Motion: moveaccuracy = bilinear not yet supported.");
		if(number == warp(HALFPIXEL, PIXEL))			throw AvisynthError("Motion: warpaccuracy = halfpixel illegal; use bilinear.");
		if(number == warp(HALFPIXEL, HALFPIXEL))	throw AvisynthError("Motion: warpaccuracy = halfpixel illegal; use bilinear.");
		if(number == warp(HALFPIXEL, BILINEAR))		throw AvisynthError("Motion: warpaccuracy = halfpixel illegal; use bilinear.");
		if(number == warp(BILINEAR, PIXEL))			return new Engines::SimpleWarpEngine<Bilinear, _Pixel>;
		if(number == warp(BILINEAR, HALFPIXEL))		return new Engines::SimpleWarpEngine<Bilinear, HalfPixel>;
		if(number == warp(BILINEAR, BILINEAR))		return new Engines::SimpleWarpEngine<Bilinear, Bilinear>;//throw AvisynthError("Motion: moveaccuracy = bilinear not yet supported.");

		throw AvisynthError("Motion: unknown engine specified.");
	}
}