
namespace Primitives
{
	template<>
	inline void copyblock_P3<4, 4, _Pixel>(unsigned char *const to, int topitch, const unsigned char *const from, int frompitch, Fractional fractional)
	{
		__asm
		{
			mov	ecx, [frompitch]
			mov	edx, [topitch]
				mov	esi, from
				mov	edi, to
			lea		eax, [ecx + 2*ecx]
			lea		ebx, [edx + 2*edx]

			//Load/compute the entire source block
			movd	mm0, [esi]
			movd	mm1, [esi + ecx]
			movd	mm2, [esi + 2*ecx]
			movd	mm3, [esi + eax]

			//move it to the destination
			movd	[edi],				mm0
			movd	[edi +	edx],		mm1
			movd	[edi +	2*edx],	mm2
			movd	[edi +	ebx],		mm3
		}
	}

	template<>
	inline void copyblock_P3<4, 4, HalfPixel>(unsigned char *const to, int topitch, const unsigned char *const from, int frompitch, Fractional fractional)
	{
		if(fractional.y() == 0)
		{
			if(fractional.x() == 0)//x
			{//INTEGER
				__asm
				{
					mov	ecx, [frompitch]
					mov	edx, [topitch]
						mov	esi, from
						mov	edi, to
					lea		eax, [ecx + 2*ecx]
					lea		ebx, [edx + 2*edx]

					//Load/compute the entire source block
					movd	mm0, [esi]
					movd	mm1, [esi + ecx]
					movd	mm2, [esi + 2*ecx]
					movd	mm3, [esi + eax]

					//move it to the destination
					movd	[edi],				mm0
					movd	[edi +	edx],		mm1
					movd	[edi +	2*edx],	mm2
					movd	[edi +	ebx],		mm3
				}
			}
			else
			{//HORIZONTAL HALF-PIXEL
				__asm
				{
					mov	ecx, [frompitch]
					mov	edx, [topitch]
						mov	esi, from
						mov	edi, to
					lea		eax, [ecx + 2*ecx]
					lea		ebx, [edx + 2*edx]

					//Load/compute the entire source block
					movd	mm0, [esi]
					movd	mm1, [esi + ecx]
					movd	mm2, [esi + 2*ecx]
					movd	mm3, [esi + eax]

					movd	mm4, [esi + 1]
					movd	mm5, [esi + ecx + 1]
					movd	mm6, [esi + 2*ecx + 1]
					movd	mm7, [esi + eax + 1]
				
					pavgb	mm0, mm4
					pavgb	mm1, mm5
					pavgb	mm2, mm6
					pavgb	mm3, mm7

					//move it to the destination
					movd	[edi],				mm0
					movd	[edi +	edx],		mm1
					movd	[edi +	2*edx],	mm2
					movd	[edi +	ebx],		mm3
				}
			}
		}
		else
		{
			if(fractional.x() == 0)
			{//VERTICAL HALF-PIXEL
				__asm
				{
					mov	ecx, [frompitch]
					mov	edx, [topitch]
						mov	esi, from
						mov	edi, to
					lea		eax, [ecx + 2*ecx]
					lea		ebx, [edx + 2*edx]

					//Load/compute the entire source block
					movd	mm0, [esi]
					movd	mm1, [esi + ecx]
					movd	mm2, [esi + 2*ecx]
					movd	mm3, [esi + eax]
					movd	mm4, [esi + 4*ecx]

					pavgb	mm0, mm1
					pavgb	mm1, mm2
					pavgb	mm2, mm3
					pavgb	mm3, mm4

					//move it to the destination
					movd	[edi],				mm0
					movd	[edi +	edx],		mm1
					movd	[edi +	2*edx],	mm2
					movd	[edi +	ebx],		mm3
				}
			}
			else
			{//BOTH HALF-PIXEL
				__asm
				{
					mov	ecx, [frompitch]
					mov	edx, [topitch]
						mov	esi, from
						mov	edi, to
					lea		eax, [ecx + 2*ecx]
					lea		ebx, [edx + 2*edx]

					//Load/compute the entire source block
					movd	mm0, [esi]
					movd mm4, [esi + 1]	

					movd	mm1, [esi + ecx]
					movd	mm5, [esi + ecx + 1]

					movd	mm2, [esi + 2*ecx]
					movd	mm6, [esi + 2*ecx + 1]

					movd	mm3, [esi + eax]
					movd	mm7, [esi + eax + 1]

						pavgb	mm0, mm4
					movd	mm4, [esi + 4*ecx]
						pavgb	mm1, mm5
					movd	mm5, [esi + 4*ecx + 1]

						pavgb	mm2, mm6
						pavgb	mm3, mm7
					pavgb	mm0, mm1
						pavgb	mm4, mm5

					pavgb	mm1, mm2
					pavgb	mm2, mm3
					pavgb	mm3, mm4

					movd	[edi],				mm0
					movd	[edi +	edx],		mm1
					movd	[edi +	2*edx],	mm2
					movd	[edi +	ebx],		mm3
				}
			}
		}
	}

}