namespace Primitives
{

	inline void /*MoveBlocks::*/copy88block_bilinear_P3(unsigned char *const to, int topitch, const unsigned char *const from, int frompitch, Fractional fractional)
	{
		//we need fractions to have 16 bits of accuracy so we can use pmulhuw
		int localfractionalx = fractional.__x << (16 - scalepower);
		int localfractionaly = fractional.__y << (16 - scalepower);
		int zero[2] = {0,0};

		if(fractional.y() == 0)
		{
			if(fractional.x() == 0)//x
			{//INTEGER
				__asm
				{
					mov	ecx, [frompitch]
					mov	edx, [topitch]
						mov	esi, from
					lea		eax, [ecx + 2*ecx]
					lea		ebx, [edx + 2*edx]

					//Load/compute the entire source block
						lea		edi, [esi + 4*ecx]
					movq	mm0, [esi]
					movq	mm1, [esi + ecx]
					movq	mm2, [esi + 2*ecx]
					movq	mm3, [esi + eax]
						mov	esi, to
					movq	mm4, [edi]
					movq	mm5, [edi + ecx]
					movq	mm6, [edi + 2*ecx]
					movq	mm7, [edi + eax]

						lea edi, [esi + 4*edx]
					//move it to the destination
					movq	[esi],				mm0
					movq	[esi +	edx],		mm1
					movq	[esi +	2*edx],	mm2
					movq	[esi +	ebx],		mm3
					movq	[edi],				mm4
					movq	[edi +	edx],		mm5
					movq	[edi +	2*edx],	mm6
					movq	[edi +	ebx],		mm7
				}
			}
			else
			{//HORIZONTAL HALF-PIXEL
				__asm
				{
					mov	ecx, [frompitch]
					mov	edx, [topitch]
						mov	esi, from
					mov	eax, [localfractionalx]
					lea		ebx, [ecx + 2*ecx]
						lea		edi, to
					
					pxor	mm7, mm7

					//pixels 0 to 11
					movd	mm0, [esi]
					movd	mm4, [esi + 1]
					movd	mm1, [esi + 4]
					movd	mm5, [esi + 4 + 1]
					movd	mm2, [esi + ecx]
					movd	mm6, [esi + ecx + 1]

					punpcklbw	mm0, mm7
					punpcklbw	mm4, mm7
					punpcklbw	mm1, mm7
					punpcklbw	mm5, mm7
					punpcklbw	mm2, mm7
					punpcklbw	mm6, mm7

					psubw		mm4, mm0
					psubw		mm5, mm1
					psubw		mm6, mm2

					pmulhw		mm4, eax
					pmulhw		mm5, eax
					pmulhw		mm6, eax

					paddw		mm0, mm4
					paddw		mm1, mm5
					paddw		mm2, mm6

					packuswb	mm0, mm1
					movq			[edi], mm0//and four bytes of result are held over in mm2 ready for the next iteration

					//pixels 12 to 23
					movd	mm0, [esi  + ecx + 4]
					movd	mm4, [esi  + ecx + 4 + 1]
					movd	mm1, [esi + 2*ecx]
					movd	mm5, [esi + 2*ecx + 1]
					movd	mm3, [esi + 2*ecx + 4]//using mm3 in place of mm2
					movd	mm6, [esi + 2*ecx + 4 + 1]

					punpcklbw	mm0, mm7
					punpcklbw	mm4, mm7
					punpcklbw	mm1, mm7
					punpcklbw	mm5, mm7
					punpcklbw	mm3, mm7
					punpcklbw	mm6, mm7

					psubw		mm4, mm0
					psubw		mm5, mm1
					psubw		mm6, mm3

					pmulhw		mm4, eax
					pmulhw		mm5, eax
					pmulhw		mm6, eax

					paddw		mm0, mm4
					paddw		mm1, mm5
					paddw		mm3, mm6

					packuswb	mm2, mm0//using four bytes of result are held over in mm2 
					packuswb	mm1, mm3
					movq			[edi + edx], mm2
					movq			[edi + 2*edx], mm2

					//advance both pointers by three rows (should interleave this inside the multiplies)
					lea				edi,  [edi + 2*edx]
					lea				esi,  [esi + ebx]
					lea				edi,  [edi + edx]

					//pixels 24 to 35
					movd	mm0, [esi]
					movd	mm4, [esi + 1]
					movd	mm1, [esi + 4]
					movd	mm5, [esi + 4 + 1]
					movd	mm2, [esi + ecx]
					movd	mm6, [esi + ecx + 1]

					punpcklbw	mm0, mm7
					punpcklbw	mm4, mm7
					punpcklbw	mm1, mm7
					punpcklbw	mm5, mm7
					punpcklbw	mm2, mm7
					punpcklbw	mm6, mm7

					psubw		mm4, mm0
					psubw		mm5, mm1
					psubw		mm6, mm2

					pmulhw		mm4, eax
					pmulhw		mm5, eax
					pmulhw		mm6, eax

					paddw		mm0, mm4
					paddw		mm1, mm5
					paddw		mm2, mm6

					packuswb	mm0, mm1
					movq			[edi], mm0//and four bytes of result are held over in mm2 ready for the next iteration

					//pixels 36 to 48
					movd	mm0, [esi  + ecx + 4]
					movd	mm4, [esi  + ecx + 4 + 1]
					movd	mm1, [esi + 2*ecx]
					movd	mm5, [esi + 2*ecx + 1]
					movd	mm3, [esi + 2*ecx + 4]//using mm3 in place of mm2
					movd	mm6, [esi + 2*ecx + 4 + 1]

					punpcklbw	mm0, mm7
					punpcklbw	mm4, mm7
					punpcklbw	mm1, mm7
					punpcklbw	mm5, mm7
					punpcklbw	mm3, mm7
					punpcklbw	mm6, mm7

					psubw		mm4, mm0
					psubw		mm5, mm1
					psubw		mm6, mm3

					pmulhw		mm4, eax
					pmulhw		mm5, eax
					pmulhw		mm6, eax

					paddw		mm0, mm4
					paddw		mm1, mm5
					paddw		mm3, mm6

					packuswb	mm2, mm0//using four bytes of result are held over in mm2 
					packuswb	mm1, mm3
					movq			[edi + edx], mm2
					movq			[edi + 2*edx], mm2

					//advance both pointers by three rows (should interleave this inside the multiplies)
					lea				edi,  [edi + 2*edx]
					lea				esi,  [esi + ebx]
					lea				edi,  [edi + edx]

			




				}
			}
		}
		else
		{
			if(fractional.x() == 0)
			{//VERTICAL HALF-PIXEL
				__asm
				{
					mov	ecx, [frompitch]
					mov	edx, [topitch]
						mov	esi, from
					lea		eax, [ecx + 2*ecx]
					lea		ebx, [edx + 2*edx]
						lea		edi, [esi + 4*ecx]

					//Load/compute the entire source block
					movq	mm0, [esi]
					movq	mm1, [esi + ecx]
					movq	mm2, [esi + 2*ecx]
					movq	mm3, [esi + eax]
					//	mov	esi, to
					movq	mm4, [edi]
					movq	mm5, [edi + ecx]
					movq	mm6, [edi + 2*ecx]
					movq	mm7, [edi + eax]
					//	lea		edi, [esi + 4*ecx]
					pavgb	mm0, mm1
					pavgb	mm1, mm2
					pavgb	mm2, mm3
					pavgb	mm3, mm4
						mov	esi, to
					pavgb	mm4, mm5
					pavgb	mm5, mm6
					pavgb	mm6, mm7
					pavgb	mm7, [edi + 4*ecx]


						lea edi, [esi + 4*edx]
					//move it to the destination
					movq	[esi],				mm0
					movq	[esi +	edx],		mm1
					movq	[esi +	2*edx],	mm2
					movq	[esi +	ebx],		mm3
					movq	[edi],				mm4
					movq	[edi +	edx],		mm5
					movq	[edi +	2*edx],	mm6
					movq	[edi +	ebx],		mm7
				}
			}
			else
			{//BOTH HALF-PIXEL
				__asm
				{
					mov	ecx, [frompitch]
					mov	edx, [topitch]
						mov	esi, from
					lea		eax, [ecx + 2*ecx]
					lea		ebx, [edx + 2*edx]
						lea		edi, [esi + 4*ecx]

					//Load/compute the entire source block
					movq	mm0, [esi]
					movq	mm1, [esi + ecx]
					movq	mm2, [esi + 2*ecx]
					movq	mm3, [esi + eax]
					//	mov	esi, to
					movq	mm4, [edi]
					movq	mm5, [edi + ecx]
					movq	mm6, [edi + 2*ecx]
					movq	mm7, [edi + eax]
					//	lea		edi, [esi + 4*ecx]
					pavgb	mm0, [esi + 1]
					pavgb	mm1, [esi + ecx + 1]
					pavgb	mm2, [esi + 2*ecx + 1]
					pavgb	mm3, [esi + eax + 1]
						mov	esi, to
					pavgb	mm4, [edi + 1]
					pavgb	mm5, [edi + ecx + 1]
					pavgb	mm6, [edi + 2*ecx + 1]
					pavgb	mm7, [edi + eax + 1]

					pavgb	mm0, mm1
					pavgb	mm1, mm2
					pavgb	mm2, mm3
							movq	[esi],				mm0
					movq	mm0, [edi + 4*ecx]
					pavgb	mm3, mm4
							movq	[esi +	edx],		mm1
							movq	[esi +	2*edx],	mm2
							movq	[esi +	ebx],		mm3
					pavgb	mm0, [edi + 4*ecx+1]//edi = source frame
							lea edi, [esi + 4*edx]//edi now points to target frame
					pavgb	mm4, mm5
					pavgb	mm5, mm6
					pavgb	mm6, mm7
					pavgb	mm7, mm0

							//move it to the destination
							movq	[edi],				mm4
							movq	[edi +	edx],		mm5
							movq	[edi +	2*edx],	mm6
							movq	[edi +	ebx],		mm7
				}
			}
		}
	}

}