#pragma once

namespace Primitives
{

	template<int width, int height, class Interpolation>
	inline void copyblock_P3(unsigned char *const to, int topitch, const unsigned char *const from, int frompitch, Fractional fractional);


	template<>
	inline void copyblock_P3<8, 8, class _Pixel>(unsigned char *const to, int topitch, const unsigned char *const from, int frompitch, Fractional)
	{
		__asm
		{
			mov	ecx, [frompitch]
			mov	edx, [topitch]
				mov	esi, from
			lea		eax, [ecx + 2*ecx]
			lea		ebx, [edx + 2*edx]

			//Load/compute the entire source block
				lea		edi, [esi + 4*ecx]
			movq	mm0, [esi]
			movq	mm1, [esi + ecx]
			movq	mm2, [esi + 2*ecx]
			movq	mm3, [esi + eax]
				mov	esi, to
			movq	mm4, [edi]
			movq	mm5, [edi + ecx]
			movq	mm6, [edi + 2*ecx]
			movq	mm7, [edi + eax]

				lea edi, [esi + 4*edx]
			//move it to the destination
			movq	[esi],				mm0
			movq	[esi +	edx],		mm1
			movq	[esi +	2*edx],	mm2
			movq	[esi +	ebx],		mm3
			movq	[edi],				mm4
			movq	[edi +	edx],		mm5
			movq	[edi +	2*edx],	mm6
			movq	[edi +	ebx],		mm7
		}
	}

	template<>
	inline void copyblock_P3<8, 8, class HalfPixel>(unsigned char *const to, int topitch, const unsigned char *const from, int frompitch, Fractional fractional)
	{
		if(fractional.y() == 0)
		{
			if(fractional.x() == 0)//x
			{//INTEGER
				__asm
				{
					mov	ecx, [frompitch]
					mov	edx, [topitch]
						mov	esi, from
					lea		eax, [ecx + 2*ecx]
					lea		ebx, [edx + 2*edx]

					//Load/compute the entire source block
						lea		edi, [esi + 4*ecx]
					movq	mm0, [esi]
					movq	mm1, [esi + ecx]
					movq	mm2, [esi + 2*ecx]
					movq	mm3, [esi + eax]
						mov	esi, to
					movq	mm4, [edi]
					movq	mm5, [edi + ecx]
					movq	mm6, [edi + 2*ecx]
					movq	mm7, [edi + eax]

						lea edi, [esi + 4*edx]
					//move it to the destination
					movq	[esi],				mm0
					movq	[esi +	edx],		mm1
					movq	[esi +	2*edx],	mm2
					movq	[esi +	ebx],		mm3
					movq	[edi],				mm4
					movq	[edi +	edx],		mm5
					movq	[edi +	2*edx],	mm6
					movq	[edi +	ebx],		mm7
				}
			}
			else
			{//HORIZONTAL HALF-PIXEL
				__asm
				{
					mov	ecx, [frompitch]
					mov	edx, [topitch]
						mov	esi, from
					lea		eax, [ecx + 2*ecx]
					lea		ebx, [edx + 2*edx]
						lea		edi, [esi + 4*ecx]

					//Load/compute the entire source block
					movq	mm0, [esi]
					movq	mm1, [esi + ecx]
					movq	mm2, [esi + 2*ecx]
					movq	mm3, [esi + eax]
					//	mov	esi, to
					movq	mm4, [edi]
					movq	mm5, [edi + ecx]
					movq	mm6, [edi + 2*ecx]
					movq	mm7, [edi + eax]
					//	lea		edi, [esi + 4*ecx]
					pavgb	mm0, [esi + 1]
					pavgb	mm1, [esi + ecx + 1]
					pavgb	mm2, [esi + 2*ecx + 1]
					pavgb	mm3, [esi + eax + 1]
						mov	esi, to
					pavgb	mm4, [edi + 1]
					pavgb	mm5, [edi + ecx + 1]
					pavgb	mm6, [edi + 2*ecx + 1]
					pavgb	mm7, [edi + eax + 1]


						lea edi, [esi + 4*edx]
					//move it to the destination
					movq	[esi],				mm0
					movq	[esi +	edx],		mm1
					movq	[esi +	2*edx],	mm2
					movq	[esi +	ebx],		mm3
					movq	[edi],				mm4
					movq	[edi +	edx],		mm5
					movq	[edi +	2*edx],	mm6
					movq	[edi +	ebx],		mm7
				}
			}
		}
		else
		{
			if(fractional.x() == 0)
			{//VERTICAL HALF-PIXEL
				__asm
				{
					mov	ecx, [frompitch]
					mov	edx, [topitch]
						mov	esi, from
					lea		eax, [ecx + 2*ecx]
					lea		ebx, [edx + 2*edx]
						lea		edi, [esi + 4*ecx]

					//Load/compute the entire source block
					movq	mm0, [esi]
					movq	mm1, [esi + ecx]
					movq	mm2, [esi + 2*ecx]
					movq	mm3, [esi + eax]
					//	mov	esi, to
					movq	mm4, [edi]
					movq	mm5, [edi + ecx]
					movq	mm6, [edi + 2*ecx]
					movq	mm7, [edi + eax]
					//	lea		edi, [esi + 4*ecx]
					pavgb	mm0, mm1
					pavgb	mm1, mm2
					pavgb	mm2, mm3
					pavgb	mm3, mm4
						mov	esi, to
					pavgb	mm4, mm5
					pavgb	mm5, mm6
					pavgb	mm6, mm7
					pavgb	mm7, [edi + 4*ecx]


						lea edi, [esi + 4*edx]
					//move it to the destination
					movq	[esi],				mm0
					movq	[esi +	edx],		mm1
					movq	[esi +	2*edx],	mm2
					movq	[esi +	ebx],		mm3
					movq	[edi],				mm4
					movq	[edi +	edx],		mm5
					movq	[edi +	2*edx],	mm6
					movq	[edi +	ebx],		mm7
				}
			}
			else
			{//BOTH HALF-PIXEL
				__asm
				{
					mov	ecx, [frompitch]
					mov	edx, [topitch]
						mov	esi, from
					lea		eax, [ecx + 2*ecx]
					lea		ebx, [edx + 2*edx]
						lea		edi, [esi + 4*ecx]

					//Load/compute the entire source block
					movq	mm0, [esi]
					movq	mm1, [esi + ecx]
					movq	mm2, [esi + 2*ecx]
					movq	mm3, [esi + eax]
					//	mov	esi, to
					movq	mm4, [edi]
					movq	mm5, [edi + ecx]
					movq	mm6, [edi + 2*ecx]
					movq	mm7, [edi + eax]
					//	lea		edi, [esi + 4*ecx]
					pavgb	mm0, [esi + 1]
					pavgb	mm1, [esi + ecx + 1]
					pavgb	mm2, [esi + 2*ecx + 1]
					pavgb	mm3, [esi + eax + 1]
						mov	esi, to
					pavgb	mm4, [edi + 1]
					pavgb	mm5, [edi + ecx + 1]
					pavgb	mm6, [edi + 2*ecx + 1]
					pavgb	mm7, [edi + eax + 1]

					pavgb	mm0, mm1
					pavgb	mm1, mm2
					pavgb	mm2, mm3
							movq	[esi],				mm0
					movq	mm0, [edi + 4*ecx]
					pavgb	mm3, mm4
							movq	[esi +	edx],		mm1
							movq	[esi +	2*edx],	mm2
							movq	[esi +	ebx],		mm3
					pavgb	mm0, [edi + 4*ecx+1]//edi = source frame
							lea edi, [esi + 4*edx]//edi now points to target frame
					pavgb	mm4, mm5
					pavgb	mm5, mm6
					pavgb	mm6, mm7
					pavgb	mm7, mm0

							//move it to the destination
							movq	[edi],				mm4
							movq	[edi +	edx],		mm5
							movq	[edi +	2*edx],	mm6
							movq	[edi +	ebx],		mm7
				}
			}
		}
	}
}
