
namespace Primitives
{
	template<int blocksize>
	inline void copyblock_bilinear(unsigned char *const to, int topitch, const unsigned char *const from, int frompitch, Fractional fractional)
	{ 
			const int weight00 = semiscaledpart(scale-fractional.x())	*semiscaledpart(scale-fractional.y());
			const int weight01 = semiscaledpart(scale-fractional.x())	*semiscaledpart(fractional.y());
			const int weight10 = semiscaledpart(fractional.x())				*semiscaledpart(scale-fractional.y());
			const int weight11 = semiscaledpart(fractional.x())				*semiscaledpart(fractional.y());

			unsigned char *toscan = to;
			const unsigned char *fromscan = from;

		if(fractional.y() == 0)
		{
			if(fractional.x() == 0)//x
			{//INTEGER
				for(int y = 0; y < blocksize; ++y, toscan += topitch, fromscan += frompitch)
					for(int x = 0; x < blocksize; ++x)
						*(reinterpret_cast<double *>(toscan)) = *(reinterpret_cast<const double *>(fromscan));

			}
			else
			{//HORIZONTAL SUB-PIXEL
				for(int y = 0; y < blocksize; ++y, toscan += topitch, fromscan += frompitch)
					for(int x = 0; x < blocksize; ++x)
						toscan[x] = (
							weight00*fromscan[x]+
							weight10*fromscan[x+1]+
							scale/2)/(scale);
			}
		}
		else
		{
			if(fractional.x() == 0)
			{//VERTICAL SUB-PIXEL
				for(int y = 0; y < blocksize; ++y, toscan += topitch, fromscan += frompitch)
					for(int x = 0; x < blocksize; ++x)
						toscan[x] = (
							weight00*fromscan[x]+
							weight01*fromscan[x+ frompitch]+
							scale/2)/(scale);
			}
			else
			{//BOTH SUB-PIXEL
				for(int y = 0; y < blocksize; ++y, toscan += topitch, fromscan += frompitch)
					for(int x = 0; x < blocksize; ++x)
						toscan[x] = (
							weight00*fromscan[x]+
							weight01*fromscan[x+ frompitch]+
							weight10*fromscan[x+1]+
							weight11*fromscan[x+ frompitch+1]+
							scale/2)/(scale);
			}
		}
	}

	template<>
	inline void copyblock_P3<2, 2, Bilinear>(unsigned char *const to, int topitch, const unsigned char *const from, int frompitch, Fractional fractional)
	{ 
		copyblock_bilinear<2>(to, topitch, from, frompitch, fractional);
	}

	template<>
	inline void copyblock_P3<4, 4, Bilinear>(unsigned char *const to, int topitch, const unsigned char *const from, int frompitch, Fractional fractional)
	{ 
		copyblock_bilinear<4>(to, topitch, from, frompitch, fractional);
	}

	template<>
	inline void copyblock_P3<8, 8, Bilinear>(unsigned char *const to, int topitch, const unsigned char *const from, int frompitch, Fractional fractional)
	{ 
		copyblock_bilinear<8>(to, topitch, from, frompitch, fractional);
	}

}