#include "stdafx.h"
//
//namespace Filters
//{

	PMotionFrame::PMotionFrame(IScriptEnvironment *env, VideoInfo vi)
	{
		frame = env->NewVideoFrame(vi);
	}

	void MotionClip::checkmatch(VideoInfo vi)
	{
		//check that the motion clip is of the right size
		int expectedwidth = vi.width/8*sizeof(CompressedMotionVector)/4;
		int expectedheight = vi.height/8;
		//if(expectedheight % 2 == 1)
		//	++expectedheight;//this will be unnecessary once we have Y8

		VideoInfo motionvideoinfo = clip->GetVideoInfo();
		if (!motionvideoinfo.IsRGB32())
			throw AvisynthError("Motion: invalid motion clip.");
		if(motionvideoinfo.width != expectedwidth || motionvideoinfo.height != expectedheight)
			throw AvisynthError("Motion: motion clip has wrong size.");
	}

	MotionFilter::MotionFilter(PClip _child) : GenericVideoFilter(_child) 
	{
		if (!vi.IsYV12())
			throw AvisynthError("Motion requires YV12.");
		if (vi.width % 8 != 0 || vi.height % 8 != 0)
			throw AvisynthError("Motion requires mod 8 width and height.");
		//change the frame size to receive motion vectors
		vi.pixel_type = VideoInfo::CS_BGR32;
		vi.width = (vi.width/8)*sizeof(CompressedMotionVector)/4;
		vi.height = (vi.height/8);
		//if(vi.height % 2 == 1)
		//	++vi.height;//this will be unnecessary once we have Y8
	}
//}