#pragma once
//included in stdafx.h

//namespace Filters
//{

	class PMotionFrame
	{
		PVideoFrame frame;
	public:
		PMotionFrame(PVideoFrame _frame) : frame(_frame) {}
		PMotionFrame(IScriptEnvironment *env, VideoInfo vi);
		PVideoFrame tovideoframe() {return frame;}
		const CompressedMotionVector *GetReadPtr() const
			{return reinterpret_cast<const CompressedMotionVector *>(frame->GetReadPtr());}
		CompressedMotionVector *GetWritePtr()
			{return reinterpret_cast<CompressedMotionVector *>(frame->GetWritePtr());}
		int GetPitch() const
			{return frame->GetPitch()/sizeof(CompressedMotionVector);}
		int GetWidth() const
			{return frame->GetRowSize()/sizeof(CompressedMotionVector);}
		int GetHeight() const
			{return frame->GetHeight();}
	};
	class MotionClip
	{
		PClip clip;
	public:
		MotionClip(PClip _clip) : clip(_clip) {}
		void checkmatch(VideoInfo);
		PMotionFrame GetFrame(int n, IScriptEnvironment *env) {return PMotionFrame(clip->GetFrame(n, env));}
		int GetWidth() const
			{return clip->GetVideoInfo().width*4/sizeof(CompressedMotionVector);}
		int GetHeight() const
			{return clip->GetVideoInfo().height;}	
	};
	class MotionFilter : public GenericVideoFilter 
	{
	public:
		MotionFilter(PClip _child);
		PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment *env) 
		{return GetMotionFrame(n, env).tovideoframe();}
		virtual PMotionFrame GetMotionFrame(int n, IScriptEnvironment *env) = 0;
	};

//}