#pragma once
#include "Update.h"

namespace Primitives
{

	struct SearchCandidate
	{
		MotionVector motionvector;
		int penalty;
		int offset;//as a difference of pointers to the previous frame
		//unsigned short fractionalx, fractionaly;
		Fractional fractional;
		SearchCandidate() {}
		SearchCandidate(MotionVector _vector, int _penalty, int pitch) 
			: motionvector(_vector), penalty(_penalty), 
			offset(integralpart(+_vector.x) + integralpart(+_vector.y)*pitch), 
			fractional(+_vector.x, +_vector.y ) {}
		SearchCandidate(MotionVector _vector, int _penalty, int _offset, unsigned int _fractionalx, unsigned int _fractionaly) 
			: motionvector(_vector), penalty(_penalty), offset(_offset), fractional(_fractionalx, _fractionaly) {}
	};

	template<class Interpolation>
	inline int search(const unsigned char *const currentposition, const int currentpitch, const unsigned char *const previousposition, const int previouspitch, SearchCandidate candidates[], int nocandidates);

	//WARNING: assembly functions do not call emms
	template<class Interpolation>
	inline int search_P3(const unsigned char *const currentposition, const int currentpitch, const unsigned char *const previousposition, const int previouspitch, SearchCandidate candidates[], int nocandidates);

}