#pragma once
#include "search.h"

namespace Primitives
{

	inline int average (int a, int b)
	{
		return (a+b+1)/2;
	}
	//template<class Interpolation>
	//inline int search(const unsigned char *const currentposition, const int currentpitch, const unsigned char *const previousposition, const int previouspitch, SearchCandidate candidates[], int nocandidates);
	//template<class Interpolation>
	//inline int search_P3(const unsigned char *const currentposition, const int currentpitch, const unsigned char *const previousposition, const int previouspitch, SearchCandidate candidates[], int nocandidates);

	template<>
	inline int search<HalfPixel>(const unsigned char *const currentposition, const int currentpitch, const unsigned char *const previousposition, const int previouspitch, SearchCandidate candidates[], int nocandidates)
	{

	throw AvisynthError("Motion: half-pixel accuracy with useassembly = false has been disabled.");
	return 0;
	}
	/*
	inline int Update::bilinearsearch(const unsigned char *const currentposition, const unsigned char *const previousposition, Candidate candidates[], int nocandidates)
	{
		int bestnumber = -1;
		int bestweight = 8*8*(256 + 4)*64;

		const unsigned char *previousend = previouspointer + height * previouspitch + width;
		for(int i = 0; i < nocandidates; ++i)
		{
			const unsigned char *const previousblock = previousposition + candidates[i].offset;

			const unsigned char *adjustedpreviousblock = previousblock;
			//make sure we aren't reading past the end of the frame in the integer case
			int adjustedfractionalx = candidates[i].fractional.x();
			int adjustedfractionaly = candidates[i].fractional.y();
			if(adjustedpreviousblock + previouspitch*8 + 8 >= previousend)
			{
				if(adjustedfractionalx == 0)
					--adjustedpreviousblock, adjustedfractionalx += scale;
				if(adjustedfractionaly == 0)
					adjustedpreviousblock -= previouspitch, adjustedfractionaly += scale;
				if(adjustedpreviousblock + previouspitch*8 + 8 >= previousend)
					throw AvisynthError("Motion: Bilinear search: Unable to adjust candidate to lie in frame");
			}	

			//kernel in explicit form, weightxy
			const int weight00 = (scale-adjustedfractionalx)	*(scale-adjustedfractionaly);
			const int weight01 = (scale-adjustedfractionalx)	*(adjustedfractionaly);
			const int weight10 = (adjustedfractionalx)			*(scale-adjustedfractionaly);
			const int weight11 = (adjustedfractionalx)			*(adjustedfractionaly);

			int weight = candidates[i].penalty;
			const unsigned char *currentscan = currentposition;
			const unsigned char *previousscan = adjustedpreviousblock;
			for(int y = 0; y < 8; ++y, currentscan += currentpitch, previousscan += previouspitch)
				for(int x = 0; x < 8; ++x)
				{
					int previouspixel = (
						weight00*previousscan[x]+
						weight01*previousscan[x+ previouspitch]+
						weight10*previousscan[x+1]+
						weight11*previousscan[x+ previouspitch+1]+
						scale/2)/(scale*scale);
					weight += abs( currentscan[x] - previouspixel );
				}

			if(weight < bestweight)
				bestnumber = i, bestweight = weight;
		}

		return bestnumber;
	}*/

	template<>
	inline int search_P3<HalfPixel>(const unsigned char *const currentposition, const int currentpitch, const unsigned char *const previousposition, const int previouspitch, SearchCandidate candidates[], int nocandidates)
	{
		int localcurrentpitch = currentpitch;
		int localpreviouspitch = previouspitch;

		int bestnumber = -1;
		int bestweight = 8*8*(256 + 4)*64;

		//const unsigned char *previousend = previouspointer + height * previouspitch + width;
		for(int i = 0; i < nocandidates; ++i)
		{
			const unsigned char *const previousblock = previousposition + candidates[i].offset;

			int candidatefractionalx = candidates[i].fractional.x();
			int candidatefractionaly = candidates[i].fractional.y();
		
			int result = 0;

			//deal with the four cases separately
			if(candidatefractionaly == 0)
			{
				if(candidatefractionalx == 0)
				{//INTEGER
					__asm
					{
						mov	ecx, [localpreviouspitch]
						mov	edx, [localcurrentpitch]
							mov	esi, previousblock
						lea		eax, [ecx + 2*ecx]
						lea		ebx, [edx + 2*edx]

						//Load/compute the entire block being considered (previousblock)
							lea		edi, [esi + 4*ecx]
						movq	mm0, [esi]
						movq	mm1, [esi + ecx]
						movq	mm2, [esi + 2*ecx]
						movq	mm3, [esi + eax]
							mov	esi, currentposition
						movq	mm4, [edi]
						movq	mm5, [edi + ecx]
						movq	mm6, [edi + 2*ecx]
						movq	mm7, [edi + eax]

							lea edi, [esi + 4*edx]
						//compute SAD with the current block
						psadbw mm0, [esi]
						psadbw mm1, [esi + edx]
						psadbw mm2, [esi + 2*edx]
						psadbw mm3, [esi + ebx]
						psadbw mm4, [edi]
						psadbw mm5, [edi + edx]
						psadbw mm6, [edi + 2*edx]
						psadbw mm7, [edi + ebx]

						paddw	mm0, mm1
						paddw	mm2, mm3
						paddw	mm4, mm5
						paddw	mm6, mm7

						paddw	mm0, mm2
						paddw	mm4, mm6

						paddw	mm0, mm4

						movd eax, mm0
						mov	result, eax
					}
				}
				else
				{//HORIZONTAL HALF-PIXEL
					__asm
					{
						mov	ecx, [localpreviouspitch]
						mov	edx, [localcurrentpitch]
							mov	esi, previousblock
						lea		eax, [ecx + 2*ecx]
						lea		ebx, [edx + 2*edx]
							lea		edi, [esi + 4*ecx]

						//Load/compute the entire block being considered (previousblock)
						movq	mm0, [esi]
						movq	mm1, [esi + ecx]
						movq	mm2, [esi + 2*ecx]
						movq	mm3, [esi + eax]
						//	mov	esi, currentposition
						movq	mm4, [edi]
						movq	mm5, [edi + ecx]
						movq	mm6, [edi + 2*ecx]
						movq	mm7, [edi + eax]
						//	lea		edi, [esi + 4*ecx]
						pavgb	mm0, [esi + 1]
						pavgb	mm1, [esi + ecx + 1]
						pavgb	mm2, [esi + 2*ecx + 1]
						pavgb	mm3, [esi + eax + 1]
							mov	esi, currentposition
						pavgb	mm4, [edi + 1]
						pavgb	mm5, [edi + ecx + 1]
						pavgb	mm6, [edi + 2*ecx + 1]
						pavgb	mm7, [edi + eax + 1]


							lea edi, [esi + 4*edx]
						//compute SAD with the current block
						psadbw mm0, [esi]
						psadbw mm1, [esi + edx]
						psadbw mm2, [esi + 2*edx]
						psadbw mm3, [esi + ebx]
						psadbw mm4, [edi]
						psadbw mm5, [edi + edx]
						psadbw mm6, [edi + 2*edx]
						psadbw mm7, [edi + ebx]

						paddw	mm0, mm1
						paddw	mm2, mm3
						paddw	mm4, mm5
						paddw	mm6, mm7

						paddw	mm0, mm2
						paddw	mm4, mm6

						paddw	mm0, mm4

						movd eax, mm0
						mov	result, eax
					}
				}
			}
			else
			{
				if(candidatefractionalx == 0)
				{//VERTICAL HALF-PIXEL
									__asm
					{
						mov	ecx, [localpreviouspitch]
						mov	edx, [localcurrentpitch]
							mov	esi, previousblock
						lea		eax, [ecx + 2*ecx]
						lea		ebx, [edx + 2*edx]
							lea		edi, [esi + 4*ecx]

						//Load/compute the entire block being considered (previousblock)
						movq	mm0, [esi]
						movq	mm1, [esi + ecx]
						movq	mm2, [esi + 2*ecx]
						movq	mm3, [esi + eax]
						//	mov	esi, currentposition
						movq	mm4, [edi]
						movq	mm5, [edi + ecx]
						movq	mm6, [edi + 2*ecx]
						movq	mm7, [edi + eax]
						//	lea		edi, [esi + 4*ecx]
						pavgb	mm0, mm1
						pavgb	mm1, mm2
						pavgb	mm2, mm3
						pavgb	mm3, mm4
							mov	esi, currentposition
						pavgb	mm4, mm5
						pavgb	mm5, mm6
						pavgb	mm6, mm7
						pavgb	mm7, [edi + 4*ecx]


							lea edi, [esi + 4*edx]
						//compute SAD with the current block
						psadbw mm0, [esi]
						psadbw mm1, [esi + edx]
						psadbw mm2, [esi + 2*edx]
						psadbw mm3, [esi + ebx]
						psadbw mm4, [edi]
						psadbw mm5, [edi + edx]
						psadbw mm6, [edi + 2*edx]
						psadbw mm7, [edi + ebx]

						paddw	mm0, mm1
						paddw	mm2, mm3
						paddw	mm4, mm5
						paddw	mm6, mm7

						paddw	mm0, mm2
						paddw	mm4, mm6

						paddw	mm0, mm4

						movd eax, mm0
						mov	result, eax
					}
				}
				else
				{//BOTH HALF-PIXEL
					__asm
					{
						mov	ecx, [localpreviouspitch]
						mov	edx, [localcurrentpitch]
							mov	esi, previousblock
						lea		eax, [ecx + 2*ecx]
						lea		ebx, [edx + 2*edx]
							lea		edi, [esi + 4*ecx]

						//Load/compute the entire block being considered (previousblock)
						movq	mm0, [esi]
						movq	mm1, [esi + ecx]
						movq	mm2, [esi + 2*ecx]
						movq	mm3, [esi + eax]
						//	mov	esi, currentposition
						movq	mm4, [edi]
						movq	mm5, [edi + ecx]
						movq	mm6, [edi + 2*ecx]
						movq	mm7, [edi + eax]
						//	lea		edi, [esi + 4*ecx]
						pavgb	mm0, [esi + 1]
						pavgb	mm1, [esi + ecx + 1]
						pavgb	mm2, [esi + 2*ecx + 1]
						pavgb	mm3, [esi + eax + 1]
							mov	esi, currentposition
						pavgb	mm4, [edi + 1]
						pavgb	mm5, [edi + ecx + 1]
						pavgb	mm6, [edi + 2*ecx + 1]
						pavgb	mm7, [edi + eax + 1]

						pavgb	mm0, mm1
						pavgb	mm1, mm2
								psadbw mm0, [esi]//esi points to previous frame
								psadbw mm1, [esi + edx]
						pavgb	mm2, mm3
						pavgb	mm3, mm4
								paddw	mm0, mm1//now we can reuse mm1
						movq	mm1, [edi + 4*ecx]
								psadbw mm2, [esi + 2*edx]//esi = previous frame
								psadbw mm3, [esi + ebx]//esi = previous frame
						pavgb	mm1, [edi + 4*ecx+1]//edi = current frame
								lea edi, [esi + 4*edx]//edi now points to previous frame
						pavgb	mm4, mm5
						pavgb	mm5, mm6
						pavgb	mm6, mm7
						pavgb	mm7, mm1

								//compute SAD with the current block
								psadbw mm4, [edi]
								psadbw mm5, [edi + edx]
								psadbw mm6, [edi + 2*edx]
								psadbw mm7, [edi + ebx]

								//we have already averaged mm0, mm1
								paddw	mm2, mm3
								paddw	mm4, mm5
								paddw	mm6, mm7

								paddw	mm0, mm2
								paddw	mm4, mm6

								paddw	mm0, mm4

								movd eax, mm0
								mov	result, eax
					}
				}
			}
			result += candidates[i].penalty;

			if(result < bestweight)
				bestnumber = i, bestweight = result;
		
			////CHECKING CODE
			//int referenceweight = candidates[i].penalty;
			//const unsigned char *currentscan = currentposition;
			//const unsigned char *previousscan = previousblock;
			//for(int y = 0; y < 8; ++y, currentscan += currentpitch, previousscan += previouspitch)
			//	for(int x = 0; x < 8; ++x)
			//	{
			//		if(candidatefractionaly==0)
			//		{
			//			if(candidatefractionalx==0)
			//				referenceweight += abs(  currentscan[x] - previousscan[x]  );
			//			else
			//				referenceweight += abs(  currentscan[x] - average(previousscan[x],previousscan[x+1])  );
			//		}
			//		else
			//		{
			//			if(candidatefractionalx==0)
			//				referenceweight += abs(  currentscan[x] - average(previousscan[x], previousscan[x+ previouspitch])  );
			//			else
			//				referenceweight += abs(  currentscan[x] - average(
			//				average(previousscan[x], previousscan[x+1]), average(previousscan[x+previouspitch], previousscan[x+ previouspitch+1])
			//				)  );
			//		}

			//	}
			//if(result!= referenceweight)	
			//	throw;
		}

		return bestnumber;
	}

}